/* $Id: equal.java,v 1.7 2014/01/11 23:40:48 mit Exp $ */
/* equal.java v1.3 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class equal extends Applet implements ItemListener
{
    private Choice ch100;  // x100
    private Choice ch10;   // x10
    private Choice ch1;    // x1
    private Choice chInte; // 
    private TextArea txA;
    private TextField tfM;
    private Panel PS, PN;
    private Canvas can;

    final int Cent = 1200;
    final int Fand = 220;
    final String[] IntName = 
    {"minor 2nd", "Major 2nd", "minor 3rd", "Major 3rd",
     "Perfect 4th", "Dim. 5th", "Perfect 5th", "minor 6th",
     "Major 6th", "minor 7th", "Major 7th"};
    final int[] Un = {15, 8, 5, 4, 3, 5, 2, 5, 3, 5, 8}; // 4:7->5:9
    final int[] Dn = {16, 9, 6, 5, 4, 7, 3, 8, 5, 9,15};
    private static final long serialVersionUID = 1L;

    int W;
    int H;
    int Divide;       // ʬ
    int Inter = 6;    // interval (p5th)
    int Ih = 0;       // x100
    int Iu = 1;       // x10
    int Id = 2;       // x1
    DecimalFormat df1;
    FontMetrics fm;

    public void init() {
	df1 = new DecimalFormat("#0.0##");
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	//---

	PN = new Panel();
        PN.setLayout(new FlowLayout());
        add("North", PN);

	ch100 = new Choice();
        for (int i = 0; i < 10; i++) // max 900
            ch100.addItem(""+i);
        ch100.addItemListener(this);
	ch100.select(""+Ih);
        PN.add(ch100);

	ch10 = new Choice();
        for (int i = 0; i < 10; i++) // max 90
            ch10.addItem(""+i);
        ch10.addItemListener(this);
	ch10.select(""+Iu);
        PN.add(ch10);

	ch1 = new Choice();
        for (int i = 0; i < 10; i++) // max 9
            ch1.addItem(""+i);
        ch1.addItemListener(this);
	ch1.select(""+Id);
        PN.add(ch1);

	chInte = new Choice();
	for (int i = 0; i < IntName.length; i++)
	    chInte.addItem(IntName[i]);
	chInte.addItemListener(this);
	chInte.select(IntName[Inter]);   // set P5th
        PN.add(chInte);

	tfM = new TextField(9);
	tfM.setEditable(false);
	PN.add(tfM);
	//---

	PS = new Panel();
        PS.setLayout(new FlowLayout());
        add("South", PS);

        txA = new TextArea("", 15, 40, TextArea.SCROLLBARS_BOTH);
        txA.setEditable(false);
        PS.add(txA);
	//---

	can = new MyCanvas();
        add(can, "Center");
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;

	can.setSize(W, H);
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-(ds.height+dn.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == ch100)       // x100
	    Ih = ch100.getSelectedIndex();

	if (e.getSource() == ch10)        // x10
	    Iu = ch10.getSelectedIndex();

	if (e.getSource() == ch1)         // x1
	    Id = ch1.getSelectedIndex();

	if (e.getSource() == chInte)         // interval
	    Inter = chInte.getSelectedIndex();

	can.repaint();
    }

    public void disp_cent() {
	StringBuffer str = new StringBuffer("Key#:   [Hz]: [cent]: Beats(");
	Divide = Ih*100+Iu*10+Id;
	double cn = Cent/(double)Divide;
	double beat, min = Integer.MAX_VALUE;
	int num = 0;

	str.append(Un[Inter]+" : "+Dn[Inter]+")\n");
	str.append("---------------------------------------------\n");

	for (int i = 0; i <= Divide; i++) {
	    beat = getBeats(i);
	    if (Math.abs(beat) < Math.abs(min)) {
		min = beat;
		num = i;
	    }
	    str.append(i+1);
	    str.append(d_form(getF(i)));
	    str.append(d_form(cn*i));
	    str.append(d_form(beat)).append("\n");
	}
	txA.setText(str.toString());

	tfM.setText("#"+num+d_form(min));
    }
    public double getBeats(int num) {
	return getF(num)*Un[Inter]-getF(0)*Dn[Inter];
    }
    public double getF(int num) {
	return Fand*Math.pow(2, num/(double)Divide);
    }
    public String d_form(double val) {
	return ": "+df1.format((float)val);
    }
    //-----

    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;
        public void update(Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI(g);
        }
    }

    public void paintI(Graphics g) {
	int Fsize = 16;
	Font f = new Font("Times", Font.BOLD, Fsize);
        g.setFont(f);
	fm = getFontMetrics(f);

	g.setColor(Color.darkGray);
	g.fillRect(0, 0, W, H);

	disp_cent();

	String title = Divide+" Equal Temperament";
	int len = fm.stringWidth(title);
	int x = (W-len)/2;
	int y = (H+Fsize)/2;
	g.setColor(Color.gray);
        g.drawString(title, x+1, y+1);

	g.setColor(new Color(200, 50, 50));
        g.drawString(title, x, y);
    }
}